#include <iostream>
#include <ctime>
#include <cmath>
#include <cstring>
#include <sstream>
#include <SDL/SDL.h>
//#include <SDL/SDL_image.h>
using namespace std;
const short screenw=320;
const short screenh=240;

Uint16 alphacol;
Uint16 bgcol;
SDL_Surface *screen=NULL;
SDL_Surface *font=NULL;
SDL_Surface *buttonsur=NULL;
SDL_Surface *bgsur=NULL;
SDL_Rect screenrect;
SDL_Rect urect;
SDL_Rect rfont[512];
SDL_Rect buttonrect[4];
SDL_Event event;
int fontw;
int fonth;
bool mb;
bool mbp;
bool mbr;
int mouse_x;
int mouse_y;
short keyp=-1;
bool bd[512];
bool quit;
bool debug;

double num[2];
double mem[4];
double result;
bool showresult=0;
bool resultmod=0;
bool showzero=0;
bool mem_mode=1;
int floating=0;
unsigned char type=0;
unsigned char resulthelp=1;

int temp[1];

time_t rawtime;
struct tm * timeinfo;

//extra.cpp
void redraw();
void input();
double backslash();
void add_digit(int val);
void changetype(int val);
void calc();

//SDLextra.cpp
void initSDL();
void clearSDL();
SDL_Surface *load_img(string Afilename);
void apply_surface(int x,int y,SDL_Surface* source,SDL_Surface* destination, SDL_Rect *clip=NULL);
Uint16 get_pixel(int x,int y,SDL_Surface *surface);

//font.cpp
void fontinit();
void draw_text(int x, int y, char str[256], SDL_Surface *starget, int max=320);
void draw_char(int x, int y, int str, SDL_Surface *starget);
void draw_number(int x, int y, double val, SDL_Surface *starget);
int stringw(char *cchar);
int stringw(double val);
int stringh(char *cchar);
int stringh(double val);

void eventblock();

#include "extra.cpp"
#include "SDLextra.cpp"
#include "font.cpp"
#include "eventblock.cpp"



/*
#define DB_LEFT          SDLK_LEFT
#define DB_RIGHT         SDLK_RIGHT
#define DB_UP            SDLK_UP
#define DB_DOWN          SDLK_DOWN

#define DB_Y             SDLK_LSHIFT
#define DB_A             SDLK_LCTRL
#define DB_X             SDLK_SPACE
#define DB_B             SDLK_LALT

#define DB_L             SDLK_TAB
#define DB_R             SDLK_BACKSPACE

#define DB_START         SDLK_RETURN
#define DB_SELECT        SDLK_ESCAPE
#define DB_POWER         SDLK_UNKNOWN
#define DB_HOLD          SDLK_PAUSE*/
