void redraw()
{
	time (&rawtime);
	timeinfo=localtime(&rawtime);
	draw_text(8,8,asctime(timeinfo),screen);
	
	apply_surface(296,8,font,screen,&rfont[0]);
	
	for (int i=0; i<25; i++)
		{
			if (mouse_y>80 && mb && ((mouse_x/64)+((mouse_y-80)/32)*5)==i)
			{
				if (i==16 && floating>0) apply_surface((i-((i/5)*5))*64,80+(i/5)*32,buttonsur,screen,&buttonrect[3]);
				else apply_surface((i-((i/5)*5))*64,80+(i/5)*32,buttonsur,screen,&buttonrect[1]);
			}
			else if (i==16 && floating>0) apply_surface((i-((i/5)*5))*64,80+(i/5)*32,buttonsur,screen,&buttonrect[2]);
			else apply_surface((i-((i/5)*5))*64,80+(i/5)*32,buttonsur,screen,&buttonrect[0]);
			if (debug) draw_number((i-((i/5)*5))*64,80+(i/5)*32,i,screen);
		}
	
	draw_number(32 -stringw(0.0)/2,192-(stringh(0.0)/2),0,screen);
	
	draw_number(32 -stringw(1.0)/2,160-(stringh(1.0)/2),1,screen);
	draw_number(96 -stringw(2.0)/2,160-(stringh(2.0)/2),2,screen);
	draw_number(160-stringw(3.0)/2,160-(stringh(3.0)/2),3,screen);
	
	draw_number(32 -stringw(4.0)/2,128-(stringh(4.0)/2),4,screen);
	draw_number(96 -stringw(5.0)/2,128-(stringh(5.0)/2),5,screen);
	draw_number(160-stringw(6.0)/2,128-(stringh(6.0)/2),6,screen);
	
	draw_number(32 -stringw(7.0)/2,96-(stringh(7.0)/2),7,screen);
	draw_number(96 -stringw(8.0)/2,96-(stringh(8.0)/2),8,screen);
	draw_number(160-stringw(9.0)/2,96-(stringh(9.0)/2),9,screen);
	
	draw_text(224-stringw((char*)"/")/2,96 -stringh((char*)"/")/2,(char*)"/",screen);
	draw_text(224-stringw((char*)"*")/2,128-stringh((char*)"*")/2,(char*)"*",screen);
	draw_text(224-stringw((char*)"-")/2,160-stringh((char*)"-")/2,(char*)"-",screen);
	draw_text(224-stringw((char*)"+")/2,192-stringh((char*)"+")/2,(char*)"+",screen);
	
	draw_text(288-stringw((char*)"C")/2,96 -stringh((char*)"C")/2,(char*)"C",screen);
	draw_text(288-stringw((char*)"sqrt")/2,128-stringh((char*)"sqrt")/2,(char*)"sqrt",screen);
	draw_text(288-stringw((char*)"^")/2,160-stringh((char*)"^")/2,(char*)"^",screen);
	draw_text(288-stringw((char*)"Calc")/2,192-stringh((char*)"Calc")/2,(char*)"Calc",screen);
	
	draw_text(96 -stringw((char*)".")/2,192-(stringh((char*)".")/2),(char*)".",screen);
	draw_text(160-stringw((char*)"<-")/2,192-(stringh((char*)"<-")/2),(char*)"<-",screen);
	
	for (int i=0; i<4; i++)
	{
		draw_number(32+(i*64)-stringw(mem[i])/2,224-(stringh(mem[i])/2),mem[i],screen);
	}
	if (mem_mode) draw_text(288-stringw((char*)"save")/2,224-(stringh((char*)"save")/2),(char*)"save",screen);
	else draw_text(288-stringw((char*)"load")/2,224-(stringh((char*)"load")/2),(char*)"load",screen);
	
	draw_number(8,24,num[0],screen);
	switch(type)
	{
		case 1:
		 draw_text(8+stringw(num[0]),24,(char*)"+",screen);
		 if (num[1]>0 or showzero) draw_number(8+stringw(num[0])+stringw((char*)"+"),24,num[1],screen);
		break;
		
		case 2:
		 draw_text(8+stringw(num[0]),24,(char*)"-",screen);
		 if (num[1]>0 or showzero) draw_number(8+stringw(num[0])+stringw((char*)"-"),24,num[1],screen);
		break;
		
		case 3:
		 draw_text(8+stringw(num[0]),24,(char*)"*",screen);
		 if (num[1]>0 or showzero) draw_number(8+stringw(num[0])+stringw((char*)"*"),24,num[1],screen);
		break;
		
		case 4:
		 draw_text(8+stringw(num[0]),24,(char*)"/",screen);
		 if (num[1]>0 or showzero) draw_number(8+stringw(num[0])+stringw((char*)"/"),24,num[1],screen);
		break;
		
		case 5:
		 draw_text(8+stringw(num[0]),24,(char*)"^",screen);
		 if (num[1]>0 or showzero) draw_number(8+stringw(num[0])+stringw((char*)"^"),24,num[1],screen);
		break;
	}
	
	if (showresult) draw_number(8,40,result,screen);
}

void input()
{
	if (mouse_x>=296 && mouse_x<312 && mouse_y>=8 && mouse_y<24 && mbr) {quit=1;}
		temp[0]=(((mouse_x/64))+((mouse_y-80)/32)*5);
	
	if (mbr && mouse_y>80)
	{
		switch(temp[0])
		{
			case 15:
			 add_digit(0);
			break;
			
			case 10:
			 add_digit(1);
			break;
			
			case 11:
			 add_digit(2);
			break;
			
			case 12:
			 add_digit(3);
			break;
			
			case 5:
			 add_digit(4);
			break;
			
			case 6:
			 add_digit(5);
			break;
			
			case 7:
			 add_digit(6);
			break;
			
			case 0:
			 add_digit(7);
			break;
			
			case 1:
			 add_digit(8);
			break;
			
			case 2:
			 add_digit(9);
			break;
			
			
			case 18:
			 changetype(1);
			break;
			
			case 13:
			 changetype(2);
			break;
			
			case 8:
			 changetype(3);
			break;
			
			case 3:
			 changetype(4);
			break;
			
			case 14:
			 changetype(5);
			break;
			
			case 4:
			 if (showresult) {num[0]=result; showresult=0;}
			 
			 num[0]=0;
			 num[1]=0;
			 type=0;
			 showresult=0;
			 if (floating>0) floating=1;
			 showzero=0;
			break;
			
			case 9:
			 if (type>0)
			 {
			 	showresult=1;
			 	resultmod=1;
			 	     if (type==1) result=sqrt(num[0]+num[1]);
			 	else if (type==2) result=sqrt(num[0]-num[1]);
			 	else if (type==3) result=sqrt(num[0]*num[1]);
			 	else if (type==4) result=sqrt(num[0]/num[1]);
			 }
			 else num[0]=sqrt(num[0]);
			break;
			
			case 16:
			 if (floating>0) floating=0;
			 else floating=1;
			break;
			
			case 17:
			 num[(type>0)]=backslash();
			break;
			
			case 19:
			 if (type==0) break;
			 if (showresult==0 or resultmod)
			 {
			 	     if (type==0) result=num[0];
			 	else if (type==1) result=num[0]+num[1];
			 	else if (type==2) result=num[0]-num[1];
			 	else if (type==3) result=num[0]*num[1];
			 	else if (type==4) result=num[0]/num[1];
			 	else if (type==5) result=pow(num[0],num[1]);
			 	showresult=1;
			 	resultmod=0;
			 	resulthelp=1;
			 }
			 else
			 {
			 	     if (type==1) result=result+num[1];
			 	else if (type==2) result=result-num[1];
			 	else if (type==3) result=result*num[1];
			 	else if (type==4) result=result/num[1];
			 	else if (type==5) result=pow(result,num[1]);
			 }
			break;
			
			case 20:
			case 21:
			case 22:
			case 23:
			 if (mem_mode)
			 {
			 	if (showresult) mem[temp[0]-20]=result;
			 	else if (type>0 && num[1]>0) mem[temp[0]-20]=num[1];
			 	else mem[temp[0]-20]=num[0];
			 }
			 else
			 {
			 	if (showresult) {result=mem[temp[0]-20]; showresult=0;}
			 	else if (type>0) num[1]=mem[temp[0]-20];
			 	else num[0]=mem[temp[0]-20];
			 }
			break;
			
			case 24:
			 mem_mode=(!mem_mode);
			break;
		}
	}
}

double backslash()
{
	char chtemp[32];
	double dtemp;
	snprintf(chtemp, sizeof(chtemp), "%g", num[(type>0)]);
	
	if (chtemp[0]=='0' && chtemp[1]==0) {type=0; showzero=0;}
	for (int i=0; i<32; i++)
	{
		if (chtemp[i]==0)
		{
			if (i>0) chtemp[i-1]=0;
			break;
		}
	}
	
	dtemp=strtod(chtemp,NULL);
	showresult=0;
	return dtemp;
}

void add_digit(int val)
{
	char chtemp[64];
	snprintf(chtemp, sizeof(chtemp), "%g", num[(type>0)]);
	
	if (type>0) showzero=1;
	if (showresult) showresult=0;
	if (floating)
	{
		temp[0]=0;
		for (int i=0; i<32; i++)
		{
			if (chtemp[i]=='.') temp[0]=1;
			if (chtemp[i]==0)
			{
				if (temp[0]) {chtemp[i]=48+val; chtemp[i+1]=0;}
				else
				{
					chtemp[i]='.';
					chtemp[i+1]=48+val;
					chtemp[i+2]=0;
				}
				break;
			}
		}
		num[(type>0)]=strtod(chtemp,NULL);
	}
	else num[(type>0)]=((int)num[(type>0)]*10)+val;
}

void changetype(int val)
{
	if (type>0 && num[1]>0)
	{
		     if (type==1) num[0]=num[0]+num[1];
		else if (type==2) num[0]=num[0]-num[1];
		else if (type==3) num[0]=num[0]*num[1];
		else if (type==4) num[0]=num[0]/num[1];
		else if (type==5) num[0]=pow(num[0],num[1]);
		num[1]=0;
	}
	type=val;
	num[1]=0;
	if (showresult) {num[0]=result; showresult=0; type=val;}
}

void calc()
{
	
}
