#include "func.h"

int main (int argc, char const* argv[])
{
	initSDL();
	font=load_img("samplefont.bmp");
	buttonsur=load_img("button.bmp");
	bgsur=load_img("background.bmp");
	fontinit();
	
	SDL_ShowCursor(0);
	
	for(int i=0; i<256; i++) cout << i << ": " << (char)i << endl;
	
	while(!quit)
	{
		eventblock();
		if (keyp==SDLK_ESCAPE) quit=1;
		if (bd[SDLK_TAB] && keyp==SDLK_BACKSPACE) {if (debug) debug=0; else debug=1;}
		if (debug) draw_text(0,0,(char*)"Debug",screen);
		input();
		
		redraw();
		
		SDL_Flip(screen);
		
		if (keyp=='p') SDL_SaveBMP(screen,"screenshot.bmp");
		
		apply_surface(0,0,bgsur,screen);
		//SDL_FillRect(screen,&screenrect,bgcol);
		SDL_Delay(16);
	}
	
	clearSDL();
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	return 0;
}
